#ifndef ROTACOMWIDGET_H
#define ROTACOMWIDGET_H

#include <QWidget>
#include <QPushButton>
#include "sharedviews/promptdialog.h"

namespace Ui {
class RotaComWidget;
}

class RotaComWidget : public QWidget
{
    Q_OBJECT

public:
    explicit RotaComWidget(QWidget *parent = 0);
    ~RotaComWidget();
    int m_speedLevel;

private:
    void initControl();//初始化窗体控件，包括位置、尺寸、样式
    void initResolution1910();//初始化窗体控件为1920x1080分辨率
    void initResolution1006();//初始化窗体控件为1024x600分辨率
    void initControlStyle();//初始化窗体控件样式

    //设置橙色渐变底层按钮样式
    QString setOrangeGradientBottomStyle(QString str);
    void setCompensationAngle(QPushButton *button, int idx);

private slots:
    void on_buttonOk_clicked();
    void on_buttonCancel_clicked();
    void on_pushButtonZeroCom1_clicked();
    void on_pushButtonZeroCom2_clicked();
    void on_pushButtonZeroCom3_clicked();
    void on_pushButtonZeroCom4_clicked();
    void on_pushButtonZeroCom5_clicked();
    void on_pushButtonZeroCom6_clicked();
    void on_buttonRotaZero_clicked();
    void on_buttonSinglePunch_clicked();
    void on_buttonChangeTool_clicked();
    void on_buttonJog_clicked();
    void on_buttonManualChange_clicked();
    void on_buttonChange_clicked();
    void on_buttonEnable_clicked();
    void on_buttonDisenable_clicked();
    void on_buttonChange_2_clicked();
    void on_buttonEnable_2_clicked();
    void on_buttonDisenable_2_clicked();
    void on_buttonChange_3_clicked();
    void on_buttonEnable_3_clicked();
    void on_buttonDisenable_3_clicked();
    void on_buttonChange_4_clicked();
    void on_buttonEnable_4_clicked();
    void on_buttonDisenable_4_clicked();
    void on_buttonForeward_pressed();
    void on_buttonForeward_released();
    void on_buttonReversal_pressed();
    void on_buttonReversal_released();
    void on_buttonForeward_2_pressed();
    void on_buttonForeward_2_released();
    void on_buttonReversal_2_pressed();
    void on_buttonReversal_2_released();
    void on_buttonForeward_3_pressed();
    void on_buttonForeward_3_released();
    void on_buttonReversal_3_pressed();
    void on_buttonReversal_3_released();
    void on_buttonForeward_4_pressed();
    void on_buttonForeward_4_released();
    void on_buttonReversal_4_pressed();
    void on_buttonReversal_4_released();
    void on_pushButtonZeroCom7_clicked();
    void on_pushButtonZeroCom8_clicked();
    void on_pushButtonZeroCom9_clicked();
    void on_pushButtonZeroCom10_clicked();
    void on_pushButtonZeroCom11_clicked();
    void on_pushButtonZeroCom12_clicked();

public slots:
    void slotSpeedLevel(int speedLevel);

signals:
    void signalManualColorChange();

private:
    Ui::RotaComWidget *ui;
};

#endif // ROTACOMWIDGET_H
